#ifndef __WAN_AFT_PRG_H
# define __WAN_AFT_PRG_H


#define MEMORY_TYPE_SRAM	0x00
#define MEMORY_TYPE_FLASH	0x01
#define MASK_MEMORY_TYPE_SRAM	0x10
#define MASK_MEMORY_TYPE_FLASH	0x20

#define DEF_SECTOR_FLASH	0x00
#define USER_SECTOR_FLASH	0x01

#define CMD_FLASH_UNKNOWN	0x00
#define CMD_FLASH_VERIFY	0x01
#define CMD_FLASH_PRG		0x02

#define SECTOR_FLASH_DECODE(sector_type)				\
		(sector_type == USER_SECTOR_FLASH) ? "USER" :		\
		(sector_type == DEF_SECTOR_FLASH) ? "BOOT" : "UNKNOWN"
		
struct wan_aft_cpld_;
typedef struct {
	int	(*reset)(struct wan_aft_cpld_*);
	int	(*is_protected)(struct wan_aft_cpld_*,int stype);
	int	(*flash_id)(struct wan_aft_cpld_*, int mtype, int stype, int*);
	int 	(*reload)(struct wan_aft_cpld_*, int stype);
	int	(*prg_byte)(struct wan_aft_cpld_*, int, unsigned long, unsigned char);
	unsigned char	(*read_byte)(struct wan_aft_cpld_*, int, int, unsigned long);
	int	(*erase)(struct wan_aft_cpld_*, int stype, int verify);
} aftup_flash_iface_t;

typedef struct {
	int	id;
	int	size;
} aftup_flash_t;

typedef struct wan_aft_cpld_ {
	void	*private;
	int	adptr_type;
	int	board_id;
	int	chip_id;
	int	adptr_subtype;

	aftup_flash_t		*flash;
	aftup_flash_iface_t	*iface;
} wan_aft_cpld_t;


#endif /* __WAN_AFT_PRG_H*/
